/*
* Viewer.java -TurtleKit - A 'star logo' in MadKit
* Copyright (C) 2000-2002 Fabien Michel
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

import madkit.kernel.*;
import java.awt.Color;

/** Viewer is the simulation default world displayer agent (an
    specialized Observer, it can be extended to redefine the
    default representation of patches and turtles (a square fill
    with the color return by the getColor() method of them).

    @author Fabien MICHEL
    @version 2.0 22/08/2000 */

public class Counter extends Watcher implements ReferenceableAgent
{
    PlotPanel plotPanel;
    String group;
    int cnt = 10;
    
    public Counter(String group, PlotPanel p)
    {
	super();
	plotPanel = p;
	this.group = group;
	System.out.println("[Counter] constructor");
    }

    public void activate()  
    {
	System.out.println("[Counter] activate()");
	if(!isGroup(group))
	    {
		createGroup(true, group, null, null);
	    }
	
    	requestRole(group, "counter", null);
    }

    public void end()
    {
	leaveGroup(group);
    }

    public void display()
    {
	AgentAddress [] preyArray;

	if(cnt == 0)
	    {
		preyArray = getAgentsWithRole(group, "prey");
		System.out.println("[Counter] display() : " + preyArray.length);
		plotPanel.addPoint(preyArray.length);
		cnt = 10;
	    }
	cnt --;
    }
}

