/*
* TurtleActivator.java -TurtleKit - A 'star logo' in MadKit
* Copyright (C) 2000-2002 Fabien Michel
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

import madkit.kernel.*;
import java.lang.reflect.*;
import java.util.*;

/** The TurtleActivator invoke and set the turtles nextAction variable 

  @author Fabien MICHEL
  @version 3.0 09/10/2001 */

final class TurtleActivator extends Activator
{     
    Map methodTable;
    
    public TurtleActivator(String group)
    {
	super(group, "turtle");
    }
    
    synchronized public void execute()
    {
	for (Iterator i = getAgentsIterator();i.hasNext();)
	    {
		Turtle turtle = (Turtle) i.next();
		if(turtle.live() == false)
		    {
			turtle.die();
		    }
	    }
    }    
}
